'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('react-router/lib/PropTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 * 
 */

var Link = function (_React$Component) {
  (0, _inherits3.default)(Link, _React$Component);

  function Link() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Link);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_Object$getPrototypeO = (0, _getPrototypeOf2.default)(Link)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this.onClick = function (event) {
      var allowTransition = true;

      if (_this.props.onClick) {
        _this.props.onClick(event);
      }

      if (isModifiedEvent(event) || !isLeftClickEvent(event)) {
        return;
      }

      if (event.defaultPrevented === true) {
        allowTransition = false;
      }

      // If target prop is set (e.g. to "_blank") let browser handle link.
      /* istanbul ignore if: untestable with Karma */
      if (_this.props.target) {
        if (!allowTransition) {
          event.preventDefault();
        }

        return;
      }

      event.preventDefault();

      if (allowTransition) {
        var href = _this.href;

        if (href) {
          _this.context.router.push({ pathname: href });
        }
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Link, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var Component = _props.Component;
      var className = _props.className;
      var activeClassName = _props.activeClassName;
      var style = _props.style;
      var activeStyle = _props.activeStyle;
      var props = (0, _objectWithoutProperties3.default)(_props, ['Component', 'className', 'activeClassName', 'style', 'activeStyle']);

      var href = this.href;
      var router = this.context.router;

      var external = isExternal(href);
      var active = !external && href && router.isActive({ pathname: href }, true);
      if (active && activeClassName) {
        className = (className || '') + ' ' + activeClassName;
      }
      if (active && activeStyle) {
        style = (0, _extends3.default)({}, style, { activeStyle: activeStyle });
      }
      return _react2.default.createElement(Component, (0, _extends3.default)({}, props, {
        href: href,
        active: active,
        style: style,
        className: className,
        onClick: !external && this.onClick
      }));
    }
  }, {
    key: 'href',
    get: function get() {
      var href = this.props.href;

      if (href && typeof __webpack_public_path__ !== 'undefined' && !isExternal(href)) {
        href = join(__webpack_public_path__, href);
      }
      return href;
    }
  }]);
  return Link;
}(_react2.default.Component);

Link.contextTypes = { router: _PropTypes.routerShape };
Link.defaultProps = {
  Component: 'a'
};
exports.default = Link;


function isLeftClickEvent(event) {
  return event.button === 0;
}

function isModifiedEvent(event) {
  return !!(event.metaKey || event.altKey || event.ctrlKey || event.shiftKey);
}

function isExternal(href) {
  return (/^(https?|mailto):/.exec(href)
  );
}

function join() {
  for (var _len2 = arguments.length, segments = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    segments[_key2] = arguments[_key2];
  }

  return normalize(segments.join('/'));
}

function normalize(href) {
  return href.replace(new RegExp('/+', 'g'), '/');
}
