'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Site;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactHelmet = require('react-helmet');

var _reactHelmet2 = _interopRequireDefault(_reactHelmet);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 * 
 */

function Site(_ref) {
  var meta = _ref.meta;
  var bundle = _ref.bundle;
  var content = _ref.content;
  var style = _ref.style;

  meta = meta || _reactHelmet2.default.rewind();
  return _react2.default.createElement(
    'html',
    meta.htmlAttributes.toComponent(),
    _react2.default.createElement(
      'head',
      null,
      _react2.default.createElement('meta', { charSet: 'utf8' }),
      meta.meta.toComponent(),
      style && _react2.default.createElement('style', { dangerouslySetInnerHTML: { __html: style } }),
      meta.link.toComponent(),
      bundle.css && _react2.default.createElement('link', { rel: 'stylesheet', href: bundle.css }),
      meta.title.toComponent()
    ),
    _react2.default.createElement(
      'body',
      null,
      _react2.default.createElement('div', { id: 'main', dangerouslySetInnerHTML: { __html: content } }),
      _react2.default.createElement('script', { async: true, src: bundle.js })
    )
  );
}

Site.defaultProps = {
  content: '',
  bundle: {
    js: null,
    css: null
  }
};
