#!/usr/bin/env node
'use strict';

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _express = require('express');

var _express2 = _interopRequireDefault(_express);

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _webpackDevMiddleware = require('webpack-dev-middleware');

var _webpackDevMiddleware2 = _interopRequireDefault(_webpackDevMiddleware);

var _webpackHotMiddleware = require('webpack-hot-middleware');

var _webpackHotMiddleware2 = _interopRequireDefault(_webpackHotMiddleware);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _server = require('react-dom/server');

var _utils = require('./utils');

var _compiler = require('../compiler');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 */

var debug = (0, _debug2.default)('sitegen:cmd:serve');

var args = (0, _utils.parse)();

var _args$args = (0, _slicedToArray3.default)(args.args, 1);

var entry = _args$args[0];


var compiler = (0, _compiler.createCompiler)({
  entry: entry,
  env: 'development',
  publicPath: args.publicPath
});

var compileDevMiddleware = (0, _webpackDevMiddleware2.default)(compiler, {
  quiet: false,
  stats: {
    chunks: false,
    modules: false,
    colors: true
  }
});

var compileHotMiddleware = (0, _webpackHotMiddleware2.default)(compiler, {
  log: function log() {}
});

function render(req, res, next) {
  compiler.promiseBundle.then(function (mod) {
    return res.send((0, _server.renderToStaticMarkup)(_react2.default.createElement(mod.Site, { bundle: { js: '/bundle.js' } })));
  }, function (err) {
    return next(err);
  });
}

(0, _express2.default)().use(compileDevMiddleware).use(compileHotMiddleware).use(render).listen(3000, function () {
  return debug('started listening on port 3000');
});
