'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

exports.parse = parse;
exports.error = error;
exports.log = log;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var cwd = process.cwd(); /**
                          * @copyright 2016-present, Sitegen team
                          */

function parse() {
  var configure = arguments.length <= 0 || arguments[0] === undefined ? function (p) {
    return p;
  } : arguments[0];
  var args = arguments.length <= 1 || arguments[1] === undefined ? process.argv : arguments[1];

  args = configure(_commander2.default).option('-p, --public-path [path]', 'Set public path [default: /]', '/').parse(args);

  var _args$args = (0, _slicedToArray3.default)(args.args, 1);

  var _args$args$ = _args$args[0];
  var entry = _args$args$ === undefined ? './' : _args$args$;


  if (!_fs2.default.existsSync(entry)) {
    error('site entry does not exist');
  }

  if (_fs2.default.statSync(entry)) {
    entry = _path2.default.join(cwd, entry, 'sitegen.config.js');
  }

  if (!_fs2.default.existsSync(entry)) {
    error('site entry does not exist');
  }

  args.args = [entry];

  return args;
}

function error(error) {
  var code = arguments.length <= 1 || arguments[1] === undefined ? 1 : arguments[1];

  var message = error.details || error.stack || error;
  console.error('Error:', message); // eslint-disable-line no-console
  if (code != null) {
    process.exit(code);
  }
}

function log(message) {
  console.log(message); // eslint-disable-line no-console
}
