'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.boot = boot;

var _debug = require('debug');

var _debug2 = _interopRequireDefault(_debug);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactRouter = require('react-router');

var _reactHotLoader = require('react-hot-loader');

var _Router = require('./routing/Router');

var _Router2 = _interopRequireDefault(_Router);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_debug2.default.enable(__DEBUG__); /**
                                    * @copyright 2016-present, Sitegen team
                                    * 
                                    */

var HOST_ELEMENT = 'main';

/**
 * Boot sitegen application.
 */
function boot(routes) {
  (0, _reactRouter.match)({ routes: routes, history: _reactRouter.browserHistory }, function (err, redirect, props) {
    if (err) {
      throw err;
    } else if (redirect) {
      (0, _invariant2.default)(false, 'Redirects are not supported');
    } else {
      (0, _reactDom.render)(_react2.default.createElement(
        _reactHotLoader.AppContainer,
        null,
        _react2.default.createElement(_Router2.default, props)
      ), document.getElementById(HOST_ELEMENT));
    }
  });
}
