'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var walkDirectory = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee6(fs, directory) {
    var _this5 = this;

    var files;
    return _regenerator2.default.wrap(function _callee6$(_context6) {
      while (1) {
        switch (_context6.prev = _context6.next) {
          case 0:
            _context6.next = 2;
            return fs.readdirAsync(directory).then(function (segments) {
              return _promise2.default.all(segments.map(function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(segment) {
                  var filename, stat;
                  return _regenerator2.default.wrap(function _callee5$(_context5) {
                    while (1) {
                      switch (_context5.prev = _context5.next) {
                        case 0:
                          filename = _path2.default.join(directory, segment);
                          _context5.next = 3;
                          return fs.statAsync(filename);

                        case 3:
                          stat = _context5.sent;

                          if (!stat.isDirectory()) {
                            _context5.next = 8;
                            break;
                          }

                          return _context5.abrupt('return', walkDirectory(fs, filename));

                        case 8:
                          return _context5.abrupt('return', [filename]);

                        case 9:
                        case 'end':
                          return _context5.stop();
                      }
                    }
                  }, _callee5, _this5);
                }));
                return function (_x7) {
                  return ref.apply(this, arguments);
                };
              }()));
            });

          case 2:
            files = _context6.sent;
            return _context6.abrupt('return', (0, _lodash.flatten)(files));

          case 4:
          case 'end':
            return _context6.stop();
        }
      }
    }, _callee6, this);
  }));
  return function walkDirectory(_x5, _x6) {
    return ref.apply(this, arguments);
  };
}();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _minimatch = require('minimatch');

var _minimatch2 = _interopRequireDefault(_minimatch);

var _lodash = require('lodash');

var _bluebird = require('bluebird');

var _PrefetchDependency = require('webpack/lib/dependencies/PrefetchDependency');

var _PrefetchDependency2 = _interopRequireDefault(_PrefetchDependency);

var _config = require('../config');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var MetaRegistryPlugin = function () {
  function MetaRegistryPlugin(_ref) {
    var loader = _ref.loader;
    (0, _classCallCheck3.default)(this, MetaRegistryPlugin);

    this.loader = loader;
  }

  (0, _createClass3.default)(MetaRegistryPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      compiler.plugin('compilation', function (compilation, params) {
        var normalModuleFactory = params.normalModuleFactory;
        compilation.dependencyFactories.set(_PrefetchDependency2.default, normalModuleFactory);
        compilation.plugin('normal-module-loader', function (loaderContext) {
          loaderContext.getMetaRegistry = function () {
            return _this.getMetaRegistry({
              context: loaderContext.context,
              compiler: compiler,
              compilation: compilation,
              resolve: loaderContext.resolve,
              addDependency: loaderContext.addDependency,
              addContextDependency: loaderContext.addContextDependency
            });
          };
        });
      });
    }
  }, {
    key: 'getMetaRegistry',
    value: function getMetaRegistry(context) {
      return new MetaRegistryAPI(this.loader, context);
    }
  }]);
  return MetaRegistryPlugin;
}(); /**
      * @copyright 2016-present, Sitegen team
      */

exports.default = MetaRegistryPlugin;

var MetaRegistryAPI = function () {
  function MetaRegistryAPI(loader, context) {
    (0, _classCallCheck3.default)(this, MetaRegistryAPI);

    this.loader = loader;
    this.context = context;
    this.compiler = context.compiler;
    this.compilation = context.compilation;
    this.fs = this.compiler.inputFileSystem;

    this.compilation.sitegenMetaCache = this.compilation.sitegenMetaCache || {};
    this.cache = this.compilation.sitegenMetaCache;

    (0, _bluebird.promisifyAll)(this.fs);
  }

  (0, _createClass3.default)(MetaRegistryAPI, [{
    key: '_resolve',
    value: function _resolve(req) {
      var _this2 = this;

      return new _promise2.default(function (resolve, reject) {
        return _this2.context.resolve(_this2.context.context, req, function (err, req) {
          if (err) {
            reject(err);
          } else if (module) {
            resolve(req);
          }
        });
      });
    }
  }, {
    key: '_getMeta',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(req) {
        var _this3 = this;

        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this._resolve(req);

              case 2:
                req = _context.sent;

                if (this.cache[req] === undefined) {
                  this.cache[req] = new _promise2.default(function (resolve, reject) {
                    var dep = new _PrefetchDependency2.default((0, _config.moduleRequest)(req, _this3.loader));
                    _this3.context.compilation.prefetch(_this3.context.context, dep, function (err, module) {
                      if (err) {
                        reject(err);
                      } else if (module) {
                        var source = module._source.source();
                        var meta = (0, _utils.evalAsModule)(source, req);
                        resolve(meta.default || {});
                      } else {
                        reject(new Error('cannot resolve meta for the module: ' + req));
                      }
                    });
                  });
                }
                return _context.abrupt('return', this.cache[req]);

              case 5:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _getMeta(_x) {
        return ref.apply(this, arguments);
      }

      return _getMeta;
    }()
  }, {
    key: 'getPageMeta',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(req) {
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                this.context.addDependency(req);
                return _context2.abrupt('return', this._getMeta(req));

              case 2:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function getPageMeta(_x2) {
        return ref.apply(this, arguments);
      }

      return getPageMeta;
    }()
  }, {
    key: 'getCollectionMeta',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(reqPattern) {
        var _this4 = this;

        var _parsePattern, directory, match, items;

        return _regenerator2.default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                _parsePattern = parsePattern(reqPattern, { basedir: this.context.context });
                directory = _parsePattern.directory;
                match = _parsePattern.match;


                this.context.addContextDependency(directory);

                _context4.next = 6;
                return walkDirectory(this.fs, directory);

              case 6:
                items = _context4.sent;

                items = items.filter(function (req) {
                  return match(req);
                });
                items = items.map(function () {
                  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(req) {
                    var meta;
                    return _regenerator2.default.wrap(function _callee3$(_context3) {
                      while (1) {
                        switch (_context3.prev = _context3.next) {
                          case 0:
                            _context3.next = 2;
                            return _this4._getMeta(req);

                          case 2:
                            meta = _context3.sent;
                            return _context3.abrupt('return', { meta: meta, req: req });

                          case 4:
                          case 'end':
                            return _context3.stop();
                        }
                      }
                    }, _callee3, _this4);
                  }));
                  return function (_x4) {
                    return ref.apply(this, arguments);
                  };
                }());
                return _context4.abrupt('return', _promise2.default.all(items));

              case 10:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function getCollectionMeta(_x3) {
        return ref.apply(this, arguments);
      }

      return getCollectionMeta;
    }()
  }]);
  return MetaRegistryAPI;
}();

function parsePattern(pattern, _ref2) {
  var basedir = _ref2.basedir;

  pattern = _path2.default.join(basedir, pattern);
  var matcher = new _minimatch2.default.Minimatch(pattern);
  var directory = [];
  for (var i = 0; i < matcher.set[0].length; i++) {
    if (typeof matcher.set[0][i] === 'string') {
      directory.push(matcher.set[0][i]);
    } else {
      break;
    }
  }
  if (directory.length > 1) {
    directory = directory.join('/');
  }
  return {
    directory: directory,
    match: matcher.match.bind(matcher)
  };
}
