'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 * 
 */

var PromiseAssetsPlugin = function () {
  function PromiseAssetsPlugin(_ref) {
    var name = _ref.name;
    var then = _ref.then;
    (0, _classCallCheck3.default)(this, PromiseAssetsPlugin);

    this.name = name || 'promiseAssets';
    this.then = then || function (assets) {
      return assets;
    };
  }

  (0, _createClass3.default)(PromiseAssetsPlugin, [{
    key: 'apply',
    value: function apply(compiler) {
      var _this = this;

      var pending = void 0;

      var init = function init() {
        pending = _bluebird2.default.pending();
        compiler[_this.name] = pending.promise.then(_this.then);
      };

      init();

      compiler.plugin('done', function (_ref2) {
        var compilation = _ref2.compilation;

        pending.resolve(compilation.assets);
      });
      compiler.plugin('invalid', init);
    }
  }]);
  return PromiseAssetsPlugin;
}();

exports.default = PromiseAssetsPlugin;
