'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.evalBundle = evalBundle;
exports.evalAsModule = evalAsModule;
exports.assetSource = assetSource;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _eval = require('eval');

var _eval2 = _interopRequireDefault(_eval);

var _resolve = require('resolve');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @copyright 2016-present, Sitegen team
 * 
 */

function evalBundle(assets) {
  var source = assetSource(assets['bundle.js']);
  if (source == null) {
    return {};
  } else {
    return evalAsModule('module.exports = ' + source, '<boot>', { require: require });
  }
}

function evalAsModule(source, filename, scope) {
  var dirname = _path2.default.dirname(filename);
  function localResolve(module) {
    return (0, _resolve.sync)(module, { basedir: dirname });
  }
  function localRequire(module) {
    // $FlowIssue: ...
    return require(localResolve(module));
  }
  localRequire.resolve = localResolve;
  scope = (0, _extends3.default)({
    console: console,
    process: process,
    require: localRequire,
    setTimeout: setTimeout,
    __filename: filename,
    __dirname: dirname
  }, scope);
  return (0, _eval2.default)(source, filename, scope);
}

function assetSource(asset) {
  if (!asset) {
    return null;
  }
  return asset._source ? asset._source.source() : asset.source();
}
