'use strict';

var _loaderUtils = require('loader-utils');

var _babelTypes = require('babel-types');

var _api = require('babel-plugin-ast-literal/api');

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __liftToAST = require('babel-plugin-ast-literal/lib/liftToAST').default; /**
                                                                              * @copyright 2016-present, Sitegen team
                                                                              */

var COLLECTION_CTX = require.resolve('../CollectionContext');

module.exports = function chunkLoader(_source) {
  this.cacheable();

  var query = (0, _loaderUtils.parseQuery)(this.query);

  function renderItem(item) {
    var req = query.loader + '!' + item.filename;
    return function (_param, _param2) {
      _param = __liftToAST(_param);
      _param2 = __liftToAST(_param2);
      return {
        "type": "ObjectExpression",
        "properties": [{
          "type": "ObjectProperty",
          "method": false,
          "shorthand": false,
          "computed": false,
          "key": {
            "type": "Identifier",
            "name": "item"
          },
          "value": {
            "type": "MemberExpression",
            "object": {
              "type": "CallExpression",
              "callee": {
                "type": "Identifier",
                "name": "require"
              },
              "arguments": [_param]
            },
            "property": {
              "type": "Identifier",
              "name": "default"
            },
            "computed": false
          }
        }, {
          "type": "ObjectProperty",
          "method": false,
          "shorthand": false,
          "computed": false,
          "key": {
            "type": "Identifier",
            "name": "path"
          },
          "value": _param2
        }],
        "extra": {
          "parenthesized": true,
          "parenStart": 0
        }
      };
    }(req, item.path);
  }

  return (0, _babelGenerator2.default)((0, _babelTypes.program)(function (_param3, _param4, _param5, _param6, _param7) {
    _param3 = __liftToAST(_param3);
    _param4 = __liftToAST(_param4);
    _param5 = __liftToAST(_param5);
    _param6 = __liftToAST(_param6);
    _param7 = __liftToAST(_param7);
    return [{
      "type": "VariableDeclaration",
      "declarations": [{
        "type": "VariableDeclarator",
        "id": {
          "type": "Identifier",
          "name": "React"
        },
        "init": {
          "type": "CallExpression",
          "callee": {
            "type": "Identifier",
            "name": "require"
          },
          "arguments": [{
            "type": "StringLiteral",
            "extra": {
              "rawValue": "react",
              "raw": "'react'"
            },
            "value": "react"
          }]
        }
      }],
      "kind": "var"
    }, {
      "type": "ExpressionStatement",
      "expression": {
        "type": "AssignmentExpression",
        "operator": "=",
        "left": {
          "type": "MemberExpression",
          "object": {
            "type": "Identifier",
            "name": "exports"
          },
          "property": {
            "type": "Identifier",
            "name": "default"
          },
          "computed": false
        },
        "right": {
          "type": "FunctionExpression",
          "id": {
            "type": "Identifier",
            "name": "PageWithChunk"
          },
          "generator": false,
          "expression": false,
          "async": false,
          "params": [{
            "type": "Identifier",
            "name": "props"
          }],
          "body": {
            "type": "BlockStatement",
            "body": [{
              "type": "VariableDeclaration",
              "declarations": [{
                "type": "VariableDeclarator",
                "id": {
                  "type": "Identifier",
                  "name": "page"
                },
                "init": _param3
              }],
              "kind": "var"
            }, {
              "type": "VariableDeclaration",
              "declarations": [{
                "type": "VariableDeclarator",
                "id": {
                  "type": "Identifier",
                  "name": "Context"
                },
                "init": {
                  "type": "MemberExpression",
                  "object": {
                    "type": "CallExpression",
                    "callee": {
                      "type": "Identifier",
                      "name": "require"
                    },
                    "arguments": [_param4]
                  },
                  "property": {
                    "type": "Identifier",
                    "name": "default"
                  },
                  "computed": false
                }
              }],
              "kind": "var"
            }, {
              "type": "VariableDeclaration",
              "declarations": [{
                "type": "VariableDeclarator",
                "id": {
                  "type": "Identifier",
                  "name": "Component"
                },
                "init": {
                  "type": "MemberExpression",
                  "object": {
                    "type": "CallExpression",
                    "callee": {
                      "type": "Identifier",
                      "name": "require"
                    },
                    "arguments": [_param5]
                  },
                  "property": {
                    "type": "Identifier",
                    "name": "default"
                  },
                  "computed": false
                }
              }],
              "kind": "var"
            }, {
              "type": "ReturnStatement",
              "argument": {
                "type": "CallExpression",
                "callee": {
                  "type": "MemberExpression",
                  "object": {
                    "type": "Identifier",
                    "name": "React"
                  },
                  "property": {
                    "type": "Identifier",
                    "name": "createElement"
                  },
                  "computed": false
                },
                "arguments": [{
                  "type": "Identifier",
                  "name": "Context"
                }, {
                  "type": "ObjectExpression",
                  "properties": [{
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "Component"
                    },
                    "value": {
                      "type": "Identifier",
                      "name": "Component"
                    }
                  }, {
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "pageNumber"
                    },
                    "value": _param6
                  }, {
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "pageCount"
                    },
                    "value": _param7
                  }, {
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "page"
                    },
                    "value": {
                      "type": "Identifier",
                      "name": "page"
                    }
                  }, {
                    "type": "ObjectProperty",
                    "method": false,
                    "shorthand": false,
                    "computed": false,
                    "key": {
                      "type": "Identifier",
                      "name": "props"
                    },
                    "value": {
                      "type": "Identifier",
                      "name": "props"
                    }
                  }]
                }]
              }
            }],
            "directives": []
          }
        }
      }
    }];
  }(query.chunk.map(renderItem), COLLECTION_CTX, this.resource, query.chunkNumber, query.chunkCount))).code;
};
