'use strict';

var _babylon = require('babylon');

var _babelTraverse = require('babel-traverse');

var _babelTraverse2 = _interopRequireDefault(_babelTraverse);

var _babelGenerator = require('babel-generator');

var _babelGenerator2 = _interopRequireDefault(_babelGenerator);

var _babelTypes = require('babel-types');

var types = _interopRequireWildcard(_babelTypes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function metaLoader(source) {
  this.cacheable();

  var found = null;

  (0, _babelTraverse2.default)((0, _babylon.parse)(source), {
    enter: function enter(path) {
      if (types.isAssignmentExpression(path.node) && isExportsMeta(path.node.left)) {
        found = path.node.right;
      }
    }
  });

  if (found) {
    return 'exports.default = ' + (0, _babelGenerator2.default)(found).code + ';';
  } else {
    return 'exports.default = {}'; // eslint-disable-line quotes
  }
};

function isExportsMeta(node) {
  return types.isMemberExpression(node) && types.isIdentifier(node.object) && node.object.name === 'exports' && types.isIdentifier(node.property) && node.property.name === 'meta';
}
