'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var walkDirectory = function () {
  var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee5(fs, directory) {
    var _this2 = this;

    var files;
    return _regenerator2.default.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            _context5.next = 2;
            return fs.readdirAsync(directory).then(function (segments) {
              return _promise2.default.all(segments.map(function () {
                var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee4(segment) {
                  var filename, stat;
                  return _regenerator2.default.wrap(function _callee4$(_context4) {
                    while (1) {
                      switch (_context4.prev = _context4.next) {
                        case 0:
                          filename = (0, _path2.join)(directory, segment);
                          _context4.next = 3;
                          return fs.statAsync(filename);

                        case 3:
                          stat = _context4.sent;

                          if (!stat.isDirectory()) {
                            _context4.next = 8;
                            break;
                          }

                          return _context4.abrupt('return', walkDirectory(fs, filename));

                        case 8:
                          return _context4.abrupt('return', [filename]);

                        case 9:
                        case 'end':
                          return _context4.stop();
                      }
                    }
                  }, _callee4, _this2);
                }));
                return function (_x12) {
                  return ref.apply(this, arguments);
                };
              }()));
            });

          case 2:
            files = _context5.sent;
            return _context5.abrupt('return', (0, _lodash.flatten)(files));

          case 4:
          case 'end':
            return _context5.stop();
        }
      }
    }, _callee5, this);
  }));
  return function walkDirectory(_x10, _x11) {
    return ref.apply(this, arguments);
  };
}();

var _path2 = require('path');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _bluebird = require('bluebird');

var _api = require('babel-plugin-ast-literal/api');

var _lodash = require('lodash');

var _config = require('../config');

var _Route = require('./Route');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var __liftToAST = require('babel-plugin-ast-literal/lib/liftToAST').default; /**
                                                                              * @copyright 2016-present, Sitegen team
                                                                              * 
                                                                              */

var META_LOADER = require.resolve('../loader/meta');
var CHUNK_LOADER = require.resolve('../loader/chunk');
var REACT_HOT_LOADER = require.resolve('react-hot-loader/webpack');

function requireMeta(component) {
  return function (_param) {
    _param = __liftToAST(_param);
    return {
      "type": "MemberExpression",
      "object": {
        "type": "CallExpression",
        "callee": {
          "type": "Identifier",
          "name": "require"
        },
        "arguments": [_param]
      },
      "property": {
        "type": "Identifier",
        "name": "default"
      },
      "computed": false,
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }((0, _config.moduleRequest)(component, META_LOADER));
}

var RouteCompiler = function () {
  function RouteCompiler(_ref) {
    var fs = _ref.fs;
    var split = _ref.split;
    var publicPath = _ref.publicPath;
    (0, _classCallCheck3.default)(this, RouteCompiler);

    (0, _bluebird.promisifyAll)(fs);
    this.fs = fs;
    this.split = split;
    this.publicPath = publicPath || '/';
  }

  (0, _createClass3.default)(RouteCompiler, [{
    key: 'render',
    value: function render(route) {
      return this._render(route, this.publicPath, ['']);
    }
  }, {
    key: '_render',
    value: function _render(route, path, trace) {

      if (route instanceof _Route.PageRoute) {
        return this._renderPageRoute(route, path, trace);
      } else if (route instanceof _Route.CollectionRoute) {
        return this._renderCollectionRoute(route, path, trace);
      } else if (route instanceof _Route.AssetRoute) {
        return this._renderAssetRoute(route, path, trace);
      } else {
        (0, _invariant2.default)(false, 'Unknown route: %s', route);
      }
    }
  }, {
    key: '_renderPageRoute',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(route, path, trace) {
        var indexRoute, childRoutes, key, childRoute, getComponent;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                indexRoute = void 0;
                childRoutes = [];
                _context.t0 = _regenerator2.default.keys(route.routes);

              case 3:
                if ((_context.t1 = _context.t0()).done) {
                  _context.next = 17;
                  break;
                }

                key = _context.t1.value;

                if (!(key === 'index')) {
                  _context.next = 11;
                  break;
                }

                _context.next = 8;
                return this._render(route.routes[key], null, trace);

              case 8:
                indexRoute = _context.sent;
                _context.next = 15;
                break;

              case 11:
                _context.next = 13;
                return this._render(route.routes[key], key, trace.concat(key));

              case 13:
                childRoute = _context.sent;

                childRoutes.push(childRoute);

              case 15:
                _context.next = 3;
                break;

              case 17:
                getComponent = renderGetComponent(route.component, {
                  split: this.split != undefined ? this.split : route.options.split,
                  chunkName: trace.join('/')
                });
                return _context.abrupt('return', renderRouteSpec({
                  path: path,
                  getComponent: getComponent,
                  indexRoute: indexRoute,
                  childRoutes: childRoutes,
                  meta: requireMeta(route.component)
                }));

              case 19:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function _renderPageRoute(_x, _x2, _x3) {
        return ref.apply(this, arguments);
      }

      return _renderPageRoute;
    }()
  }, {
    key: '_renderCollectionRoute',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2(route, path, trace) {
        var _this = this;

        var _route$collection, context, match, paginate, chunkName, name, items, chunks, childRoutes, getComponent;

        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _route$collection = route.collection;
                context = _route$collection.context;
                match = _route$collection.match;
                paginate = route.options.paginate;
                chunkName = trace.join('/');
                name = chunkName;
                _context2.next = 8;
                return walkDirectory(this.fs, context);

              case 8:
                items = _context2.sent;

                items = items.filter(function (filename) {
                  return match(filename);
                });
                items = items.map(function (filename) {
                  return {
                    filename: filename,
                    path: stripExtension((0, _path2.relative)(context, filename))
                  };
                });

                chunks = [items];


                if (paginate) {
                  chunks = (0, _lodash.chunk)(items, paginate.size);
                }

                chunks = chunks.map(function (chunk, idx) {
                  return renderGetCollectionChunk(chunk, {
                    page: route.component,
                    chunkNumber: idx,
                    chunkCount: chunks.length,
                    loader: META_LOADER,
                    chunkName: trace.concat('@page', idx + 1).join('/'),
                    split: _this.split != undefined ? _this.split : true
                  });
                });

                childRoutes = items.map(function (item) {
                  return renderRouteSpec({
                    path: item.path,
                    getComponent: renderGetComponent(item.filename, {
                      split: _this.split != undefined ? _this.split : true,
                      chunkName: trace.concat(item.path).join('/')
                    })
                  });
                });

                getComponent = function (_param2) {
                  _param2 = __liftToAST(_param2);
                  return {
                    "type": "FunctionExpression",
                    "id": {
                      "type": "Identifier",
                      "name": "getComponent"
                    },
                    "generator": false,
                    "expression": false,
                    "async": false,
                    "params": [{
                      "type": "Identifier",
                      "name": "nextState"
                    }, {
                      "type": "Identifier",
                      "name": "cb"
                    }],
                    "body": {
                      "type": "BlockStatement",
                      "body": [{
                        "type": "VariableDeclaration",
                        "declarations": [{
                          "type": "VariableDeclarator",
                          "id": {
                            "type": "Identifier",
                            "name": "pageNumber"
                          },
                          "init": {
                            "type": "CallExpression",
                            "callee": {
                              "type": "Identifier",
                              "name": "parseInt"
                            },
                            "arguments": [{
                              "type": "LogicalExpression",
                              "left": {
                                "type": "MemberExpression",
                                "object": {
                                  "type": "MemberExpression",
                                  "object": {
                                    "type": "Identifier",
                                    "name": "nextState"
                                  },
                                  "property": {
                                    "type": "Identifier",
                                    "name": "params"
                                  },
                                  "computed": false
                                },
                                "property": {
                                  "type": "Identifier",
                                  "name": "page"
                                },
                                "computed": false
                              },
                              "operator": "||",
                              "right": {
                                "type": "NumericLiteral",
                                "extra": {
                                  "rawValue": 1,
                                  "raw": "1"
                                },
                                "value": 1
                              }
                            }, {
                              "type": "NumericLiteral",
                              "extra": {
                                "rawValue": 10,
                                "raw": "10"
                              },
                              "value": 10
                            }]
                          }
                        }],
                        "kind": "var"
                      }, {
                        "type": "VariableDeclaration",
                        "declarations": [{
                          "type": "VariableDeclarator",
                          "id": {
                            "type": "Identifier",
                            "name": "chunkList"
                          },
                          "init": _param2
                        }],
                        "kind": "var"
                      }, {
                        "type": "VariableDeclaration",
                        "declarations": [{
                          "type": "VariableDeclarator",
                          "id": {
                            "type": "Identifier",
                            "name": "getCollectionChunk"
                          },
                          "init": {
                            "type": "MemberExpression",
                            "object": {
                              "type": "Identifier",
                              "name": "chunkList"
                            },
                            "property": {
                              "type": "BinaryExpression",
                              "left": {
                                "type": "Identifier",
                                "name": "pageNumber"
                              },
                              "operator": "-",
                              "right": {
                                "type": "NumericLiteral",
                                "extra": {
                                  "rawValue": 1,
                                  "raw": "1"
                                },
                                "value": 1
                              }
                            },
                            "computed": true
                          }
                        }],
                        "kind": "var"
                      }, {
                        "type": "ExpressionStatement",
                        "expression": {
                          "type": "CallExpression",
                          "callee": {
                            "type": "Identifier",
                            "name": "getCollectionChunk"
                          },
                          "arguments": [{
                            "type": "Identifier",
                            "name": "nextState"
                          }, {
                            "type": "Identifier",
                            "name": "cb"
                          }]
                        }
                      }],
                      "directives": []
                    },
                    "extra": {
                      "parenthesized": true,
                      "parenStart": 0
                    }
                  };
                }(chunks);

                childRoutes = childRoutes.concat(renderRouteSpec({
                  path: '@page/:page',
                  name: name,
                  params: function (_param3) {
                    _param3 = __liftToAST(_param3);
                    return {
                      "type": "ObjectExpression",
                      "properties": [{
                        "type": "ObjectProperty",
                        "method": false,
                        "shorthand": false,
                        "computed": false,
                        "key": {
                          "type": "Identifier",
                          "name": "page"
                        },
                        "value": _param3
                      }],
                      "extra": {
                        "parenthesized": true,
                        "parenStart": 0
                      }
                    };
                  }(chunks.map(function (_, idx) {
                    return idx + 1;
                  }))
                }));

                return _context2.abrupt('return', renderRouteSpec({
                  path: path,
                  getComponent: getComponent,
                  childRoutes: childRoutes,
                  name: name
                }));

              case 18:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function _renderCollectionRoute(_x4, _x5, _x6) {
        return ref.apply(this, arguments);
      }

      return _renderCollectionRoute;
    }()
  }, {
    key: '_renderAssetRoute',
    value: function () {
      var ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee3(_route, _path, _trace) {
        return _regenerator2.default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                return _context3.abrupt('return', function () {
                  return {
                    "type": "Identifier",
                    "name": "ok",
                    "extra": {
                      "parenthesized": true,
                      "parenStart": 0
                    }
                  };
                }());

              case 1:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _renderAssetRoute(_x7, _x8, _x9) {
        return ref.apply(this, arguments);
      }

      return _renderAssetRoute;
    }()
  }]);
  return RouteCompiler;
}();

exports.default = RouteCompiler;


/**
 * Render React Router route spec.
 */
function renderRouteSpec(spec) {
  return function (_param4, _param5, _param6, _param7, _param8, _param9, _param10) {
    _param4 = __liftToAST(_param4);
    _param5 = __liftToAST(_param5);
    _param6 = __liftToAST(_param6);
    _param7 = __liftToAST(_param7);
    _param8 = __liftToAST(_param8);
    _param9 = __liftToAST(_param9);
    _param10 = __liftToAST(_param10);
    return {
      "type": "ObjectExpression",
      "properties": [{
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "path"
        },
        "value": _param4
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "getComponent"
        },
        "value": _param5
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "indexRoute"
        },
        "value": _param6
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "childRoutes"
        },
        "value": _param7
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "name"
        },
        "value": _param8
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "params"
        },
        "value": _param9
      }, {
        "type": "ObjectProperty",
        "method": false,
        "shorthand": false,
        "computed": false,
        "key": {
          "type": "Identifier",
          "name": "meta"
        },
        "value": _param10
      }],
      "extra": {
        "parenthesized": true,
        "parenStart": 0
      }
    };
  }(spec.path, spec.getComponent, spec.indexRoute, spec.childRoutes || [], spec.name, spec.params, spec.meta);
}

/**
 * Render component loader to load component from a given module.
 */
function renderGetComponent(req, options) {

  options = (0, _extends3.default)({
    split: false,
    chunkName: 'component'
  }, options);

  if (options.split) {
    return function (_param11, _param12) {
      _param11 = __liftToAST(_param11);
      _param12 = __liftToAST(_param12);
      return {
        "type": "FunctionExpression",
        "id": {
          "type": "Identifier",
          "name": "getComponentAsync"
        },
        "generator": false,
        "expression": false,
        "async": false,
        "params": [{
          "type": "Identifier",
          "name": "_nextState"
        }, {
          "type": "Identifier",
          "name": "cb"
        }],
        "body": {
          "type": "BlockStatement",
          "body": [{
            "type": "ExpressionStatement",
            "expression": {
              "type": "CallExpression",
              "callee": {
                "type": "MemberExpression",
                "object": {
                  "type": "Identifier",
                  "name": "require"
                },
                "property": {
                  "type": "Identifier",
                  "name": "ensure"
                },
                "computed": false
              },
              "arguments": [{
                "type": "ArrayExpression",
                "elements": []
              }, {
                "type": "FunctionExpression",
                "id": null,
                "generator": false,
                "expression": false,
                "async": false,
                "params": [{
                  "type": "Identifier",
                  "name": "require"
                }],
                "body": {
                  "type": "BlockStatement",
                  "body": [{
                    "type": "ExpressionStatement",
                    "expression": {
                      "type": "CallExpression",
                      "callee": {
                        "type": "Identifier",
                        "name": "cb"
                      },
                      "arguments": [{
                        "type": "NullLiteral"
                      }, {
                        "type": "MemberExpression",
                        "object": {
                          "type": "CallExpression",
                          "callee": {
                            "type": "Identifier",
                            "name": "require"
                          },
                          "arguments": [_param11]
                        },
                        "property": {
                          "type": "Identifier",
                          "name": "default"
                        },
                        "computed": false
                      }]
                    }
                  }],
                  "directives": []
                }
              }, _param12]
            }
          }],
          "directives": []
        },
        "extra": {
          "parenthesized": true,
          "parenStart": 0
        }
      };
    }(req, options.chunkName);
  } else {
    return function (_param13) {
      _param13 = __liftToAST(_param13);
      return {
        "type": "FunctionExpression",
        "id": {
          "type": "Identifier",
          "name": "getComponentSync"
        },
        "generator": false,
        "expression": false,
        "async": false,
        "params": [{
          "type": "Identifier",
          "name": "_nextState"
        }, {
          "type": "Identifier",
          "name": "cb"
        }],
        "body": {
          "type": "BlockStatement",
          "body": [{
            "type": "ExpressionStatement",
            "expression": {
              "type": "CallExpression",
              "callee": {
                "type": "Identifier",
                "name": "cb"
              },
              "arguments": [{
                "type": "NullLiteral"
              }, {
                "type": "MemberExpression",
                "object": {
                  "type": "CallExpression",
                  "callee": {
                    "type": "Identifier",
                    "name": "require"
                  },
                  "arguments": [_param13]
                },
                "property": {
                  "type": "Identifier",
                  "name": "default"
                },
                "computed": false
              }]
            }
          }],
          "directives": []
        },
        "extra": {
          "parenthesized": true,
          "parenStart": 0
        }
      };
    }(req);
  }
}

/**
 * Render a fetcher for a collection chunk.
 */
function renderGetCollectionChunk(chunk, options) {

  options = (0, _extends3.default)({
    loader: META_LOADER,
    chunkName: 'collectionPage',
    split: false
  }, options);

  var query = {
    chunk: chunk,
    loader: options.loader,
    chunkNumber: options.chunkNumber,
    chunkCount: options.chunkCount
  };

  var req = (0, _config.moduleRequest)(options.page, { loader: CHUNK_LOADER, query: query },
  // TODO: we don't really want to leak configuration here, think of a better
  // way to inject this
  REACT_HOT_LOADER);
  return renderGetComponent(req, {
    split: options.split,
    chunkName: options.chunkName
  });
}

function stripExtension(filename) {
  return filename.substring(0, filename.length - (0, _path2.extname)(filename).length);
}
