'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var INITIAL_STATE = {
  location: null,
  routes: null,
  params: null,
  components: null
}; /**
    * <Router />
    *
    * This is adapted from <ReactRouter.Router /> to enable routes hot reloading
    * and strip away unneeded functionality.
    *
    * @copyright 2016-present, Sitegen team
    * 
    */

var Router = function (_React$Component) {
  (0, _inherits3.default)(Router, _React$Component);

  function Router(props) {
    (0, _classCallCheck3.default)(this, Router);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Router).call(this, props));

    _this.state = INITIAL_STATE;
    return _this;
  }

  (0, _createClass3.default)(Router, [{
    key: 'render',
    value: function render() {
      var _state = this.state;
      var location = _state.location;
      var routes = _state.routes;
      var params = _state.params;
      var components = _state.components;
      var _props = this.props;
      var _props$matchContext = _props.matchContext;
      var history = _props$matchContext.history;
      var router = _props$matchContext.router;
      var props = (0, _objectWithoutProperties3.default)(_props, ['matchContext']);


      if (location == null) {
        // Async match
        return null;
      }

      return _react2.default.createElement(_reactRouter.RouterContext, (0, _extends3.default)({}, props, {
        history: history,
        router: router,
        location: location,
        routes: routes,
        params: params,
        components: components
      }));
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.initializeRouter();
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (nextProps.history !== this.props.history || nextProps.routes !== this.props.routes) {
        this.setState(INITIAL_STATE);
        this.initializeRouter();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this._unlisten) {
        this._unlisten();
      }
    }
  }, {
    key: 'handleError',
    value: function handleError(error) {
      if (this.props.onError) {
        this.props.onError.call(this, error);
      } else {
        // Throw errors by default so we don't silently swallow them!
        // This error probably occurred in getChildRoutes or getComponents.
        throw error;
      }
    }
  }, {
    key: 'initializeRouter',
    value: function initializeRouter() {
      var _this2 = this;

      var transitionManager = this.props.matchContext.transitionManager;


      if (this._unlisten) {
        this._unlisten();
      }

      this._unlisten = transitionManager.listen(function (error, state) {
        if (error) {
          _this2.handleError(error);
        } else {
          _this2.setState(state, _this2.props.onUpdate);
        }
      });
    }
  }]);
  return Router;
}(_react2.default.Component);

exports.default = Router;
